#ifndef SOCKETWRAPPERWIN_H_
#define SOCKETWRAPPERWIN_H_
#define DllExport __declspec( dllexport )

#include <string>
#include "UniSocket.hpp"

#include <winsock2.h>
#include <windows.h>

class DllExport SocketWrapper {

private:
	SOCKADDR_IN _address;
	int _socket;
	std::string _end;

public:
	std::string _ip;
	
	SocketWrapper(void);
	
	SocketWrapper(
		const std::string & ip,
		const int & port,
		const std::string & end
	);
	
	void send(const std::string & data);
	std::string recv(void);
	void close(void);

	// server
	SocketWrapper(
		const int & port,
		const int & queueSize,
		const std::string & end
	);
	SocketWrapper(
		const SOCKADDR_IN & myAddress,
		const int & mySocket,
		const std::string & end
	);
	SocketWrapper accept(void);
};

#endif
